<template>
  <div className="row">
    <div className="large-12 columns">
      <h1>Tasks CRUD Table</h1>
      <table id="test-table">
        <thead>
        <tr>
          <th>id</th>
          <th>title</th>
        </tr>
        </thead>
        <tbody>
        <tr v-for="task in tasks" :key="task.id" :id="editableTaskId === task.id ? 'editable' : task.id">
          <template v-if="editableTaskId !== task.id">
            <th>{{ task.id }}</th>
            <th>{{ task.title }}</th>
            <th>
              <button @click="removeTask(task.id)">remove</button>
            </th>
            <th>
              <button @click="editableTaskId = task.id">edit</button>
            </th>
          </template>
          <template v-else>
            <th>{{ task.id }}</th>
            <th colspan="2">
              <input v-model="editableTaskTitle" :placeholder="task.title"></th>
            <th>
              <button @click="editTask()">edit</button>
            </th>
            <th>
              <button @click="editableTaskId = editableTaskTitle = ''">cancel</button>
            </th>
          </template>
        </tr>
        </tbody>
      </table>
      <label htmlFor="title"><input v-model="newTaskTitle" type="text" name="title" id="title"
                                    placeholder="title"/></label>
      <button @click="addNewTask" className="tiny button right">Add Task</button>
    </div>
  </div>
</template>

<script>
import axios from "axios";

export default {
  name: "tasks-table",
  data() {
    return {
      tasks: [],
      newTaskTitle: '',
      editableTaskId: '',
      editableTaskTitle: ''
    }
  },
  mounted() {
    axios
        .get('/api/tasks')
        .then(response => (this.tasks = response.data))
  },
  methods: {
    removeTask(id) {
      axios
          .delete('/api/tasks/' + id)

      this.tasks = this.tasks.filter((task) => {
        return task.id !== id;
      })
    },
    addNewTask() {
      if (this.newTaskTitle) {
        axios
            .post('/api/tasks', {'title': this.newTaskTitle})
            .then(response => {
              this.tasks.push(response.data);
              this.newTaskTitle = ''
            })
      }
    },
    editTask() {
      const taskId = this.editableTaskId;
      if (taskId) {
        axios
            .put('/api/tasks/' + taskId, {'title': this.editableTaskTitle})
            .then(response => {
              this.tasks = this.tasks.map(function (task) {
                if (task.id === taskId) {
                  task.title = response.data.title;
                }
                return task;
              });
              this.editableTaskId = ''
              this.editableTaskTitle = ''
            })
      }
    }
  }
}
</script>

<style>
td {
  text-align: center;
}
</style>